#!/usr/bin/perl

$gBaseURL = ".";
$gIconURL = "./images";
$gBaseDIR = ".";
$gCGI_URL = "./board.cgi";

$gMakeBoard = "Y"; 	 
$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
    local($buffer,$data,$name,$value);
    local(@datum);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    }

    @datum = split(/&/,$buffer);
    foreach $data (@datum) {
        ($name,$value) = split(/=/,$data);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

        $FORM{$name} = $value;
    }
    if($FORM{'id'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'id'}";
        $gPgTitle = "<img src=$gIconURL/$FORM{'id'}.gif>";
        $gNumFile = "$FORM{'id'}.num";
        $gCfgFile = "$FORM{'id'}.cfg";
        $gPwdFile = "$FORM{'id'}.pwd";
        $gIdxFile = "$FORM{'id'}.idx";
    }
    else {
		&HTMLHeader;

		print "<form name=id>\n";
		print "<table border cellpadding=3 cellspacing=0 width=300 bgcolor=#f3f3f3 bordercolordark=#ffffff bordercolorlight=#c0c0c0>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center><font style=\"font-size:9pt\"> board cgi </font></td></tr>\n";
		print "<tr><td height=40 align=center><font style=\"font-size:9pt\">  DB  </font><input type=text name=id size=15 class=ad value=$DBname></td></tr>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center>\n";
		print "<input type=submit value=\" DB  \" style=\"height:18px;font-size:9pt;background-color:#f3f3f3;border:1 solid #787878;cursor: hand\" OnClick=\"url_go('$gCGI_URL?id=$DBname')\">\n";
		print "</table></td></tr></table>\n";
		print "</form>\n";

		&HTMLFooter;
    }
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        if($gMakeBoard eq "Y") {
            &selectAction;
        }
        else {
            &HTMLHeader;
				print "<font style=\"font-size:9pt\">ڿ   Ǿ ϴ!</font>\n";
            &HTMLFooter;
        }
    }
}

sub selectAction {
    &getEnvVar;
    &getNumber;

    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;
   
    unless($FORM{'action'}) {
        $FORM{'action'} = "read";
    }
    if($FORM{'action'} eq "read") {	
        &readData;
    } 
    elsif($FORM{'action'} eq "input_form") {
        &showInputForm;
    }
    elsif($FORM{'action'} eq "write") {
		if ($gAdminist eq "N"){
			&writeData;
		}
		else {exit;}
    }
    elsif($FORM{'action'} eq "write2") {
		if ($gAdminist eq "Y"){
			&checkAdminPassword;
			&writeData;
		}
		else {exit;}
    } 
    elsif($FORM{'action'} eq "users_login") {
        &showUsersLogin;
    }
    elsif($FORM{'action'} eq "delete") {
        &checkUserPassword;
        &deleteData;
    } 
    elsif($FORM{'action'} eq "update_form") {
        &checkUserPassword;
        &showUpdateForm;
    } 
    elsif($FORM{'action'} eq "update") {
        &updateData;
    } 
    elsif($FORM{'action'} eq "admin_login") {
        &showAdminLogin;
    }
    elsif($FORM{'action'} eq "config_form") {
        &checkAdminPassword;
        &showConfigForm;
    }
    elsif($FORM{'action'} eq "config") {
        &updateEnvVar;
    }
    elsif($FORM{'action'} eq "follow") {
        &HTMLHeader;
        &followData;
            print "<P>\n";
        &readIndexFile;
        &DirectList;
        &HTMLFooter;
    }
    elsif($FORM{'action'} eq "search") {
        &searchData;
    }
    else {
        exit;
    }
}

sub getNumber {
    local($data,$size);
    local(@datum,@value);
   
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/messages",0777);
        
        open(HANDLE,">$gBaseDIR/$gIdxFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImage = $datum[2];
        $gBoardTitle = $datum[3];
        $gBoardImage = $datum[4];
        $gTableWidth = $datum[5];
        $gRecPerPage = $datum[6];
        $gThreadNumber = $datum[7];
        $gListNumber = $datum[8];
        $gMailInform = $datum[9];
        $gAdminEmail = $datum[10];
        $gEmailPgm = $datum[11];
        $gHomeURL = $datum[12];
        $gHomeURLTarget = $datum[13];
        $gBaseText = $datum[14];
        $gLink = $datum[15];
        $gLinkVisited = $datum[16];
        $gLinkActive = $datum[17];
        $gLinkHover = $datum[18];
        $gTableCell = $datum[19];
		$gListHover = $datum[20];
        $gAdminist = $datum[21];
		$gTextSize = $datum[22];
		$gTextFamily = $datum[23];
        chop($gHomeImageURL);
    }
    else {
 
        $gBackColor = "#ffffff";
        $gBackImage = "";
        $gBoardTitle = "<font style=font-size:9pt> Խ</font>";
        $gBoardImage = "";
        $gTableWidth = "80%"; 
        $gRecPerPage = "10";
        $gThreadNumber = "4";
        $gListNumber = "5";
        $gMailInform = "Y";
        $gAdminEmail = "";
        $gEmailPgm = "/usr/sbin/sendmail";
        $gHomeURL = "";
        $gHomeURLTarget = "top";
        $gBaseText = "#84ceff"; 
        $gLink = "#84ceff";
        $gLinkVisited = "#94d6ff";
        $gLinkActive ="#94d6ff";
        $gLinkHover ="#e7f7ff";
		$gListHover = "#e7f7ff";
        $gTableCell = "#e7f7ff";
        $gAdminist = "N";
		$gTextSize = "10pt";
		$gTextFamily = ",Tahoma";
        &putEnvVar;
    }
}
 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "^^|$gBackColor|$gBackImage|$gBoardTitle|$gBoardImage|$gTableWidth|$gRecPerPage|$gThreadNumber|$gListNumber|$gMailInform|$gAdminEmail|$gEmailPgm|$gHomeURL|$gHomeURLTarget|$gBaseText|$gLink|$gLinkVisited|$gLinkActive|$gLinkHover|$gTableCell|$gListHover|$gAdminist|$gTextSize|$gTextFamily|\n";
    close(HANDLE);
}

sub readData {
    &HTMLHeader;
    &PageHeader;
    &readIndexFile;
	&DirectList;
    &PageFooter;
    &HTMLFooter;
}

sub readIndexFile {
    local($i,$j,$old_date,$new_date,$actual_number,$short_subject,$short_date);
    local(@datum,@value);
    
      print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
      print "<tr valign=middle align=center bgcolor=#87DCFF>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7' cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>No</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Subject</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Name</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Date</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Read</b></font></td></tr></table></td>\n";
   


	open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {

        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;
        if($actual_number > 0) {
	
	
        if($i%2) {
			print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
            print "<tr align=center height=22 onmouseover=this.style.backgroundColor='$gListHover' onmouseout=this.style.backgroundColor=''>\n";
		}
        else {
			print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
            print "<tr align=center height=22 onmouseover=this.style.backgroundColor='$gListHover' onmouseout=this.style.backgroundColor=''>\n";
        }

			$short_subject = substr($value[2],0,60);
            print "<td align=center><font class=ver8>$actual_number</td><td  height=22 align=left>";
            for($j=1;$j<=$value[0];$j++) {
                 print "&nbsp;&nbsp;";
            }
            $old_date = substr($value[5],0,10);
            &getDate;
            $new_date = substr($date,0,10);
            if($old_date eq $new_date) {
                if($value[0] == 0) {
                    print "&nbsp;&nbsp;<img src=$gIconURL/item.gif align=absmiddle> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/new.gif border=0 align=absmiddle></td>";
                }
                else {
                    print "&nbsp;&nbsp;<img src=$gIconURL/item_reply.gif align=absmiddle> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/new.gif border=0 align=absmiddle></td>";
                }
            }
            else {
                if($value[0] == 0) {
                    print "&nbsp;&nbsp;<img src=$gIconURL/item.gif align=absmiddle> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a></td>";
                }
                else {
                    print "&nbsp;&nbsp;<img src=$gIconURL/item_reply.gif align=absmiddle> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a></td>";
                }
            }
            if ($value[4] eq "<br>") {
                print "<td align=center>$value[3]</td>\n";
            }
            else {
                print "<td align=center><a href=mailto:$value[4] title=\"$value[4]\">$value[3]</a></td>\n";
            }
            $short_date=substr($value[5],0,10);
		print "<td align=center><font class=ver8>$short_date</td>";
		print "<td align=center><font class=ver8>$value[6]</td></tr>";
        }
    }
		print "<tr><td colspan=99 background=$gIconURL/dot.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
		print "</table>\n";
    unless($gNoOfData) {
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=1>\n";
        print "<tr align=center><td colspan=5>ϵ Խù ϴ\n";
        print "</table>\n";
    }
}

sub DirectList  {
	print "<table border=0 cellpadding=2 cellspacing=0 width=$gTableWidth>\n";
           print"<tr><td align=left><font style=\"font-size:8pt;font-family:Tahoma\"><a href=$gCGI_URL?id=$FORM{'id'}&action=input_form><img src=$gIconURL/write.gif border=0></a>&nbsp;&nbsp;</td>\n";
           print"<td align=center><font style=\"font-size:8pt;font-family:Tahoma\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=1>Top</a>&nbsp;&nbsp\n";
	$term = $gListNumber;$f = 1;$l = $term;while ($f <= $gTotPage) {
		if (($f <= $gCurPage) && ($gCurPage <= $l)) {
			$PrevPage = $f - 1;
			if ($PrevPage > 0) {
				print "&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$PrevPage><img src=$gIconURL/prev.gif border=0></a>";
			}
			if ($l <= $gTotPage) {
				for ($page = $f; $page <= $l; $page++) {
					if ($page == $gCurPage) {
						print "[$page]";
					}
					else {
						print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page>[$page]</a>";
					}
				}
			}
			else {
				for ($page = $f; $page <= $gTotPage; $page++) {
					if ($page == $gCurPage) {
						print "[$page]";
					}
					else {
						print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page>[$page]</a>";
					}
				}
			}
			$NextPage = $l + 1;
			if ($NextPage <= $gTotPage) {
				print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$NextPage><img src=$gIconURL/next.gif border=0>&nbsp;</a>";
			}
		}
		$f = $f + $term;
		$l = $l + $term;
	}
	print "</font></td>\n";
	print "<td align=right>\n";
	print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><img src=$gIconURL/index.gif border=0></a></font>&nbsp;&nbsp;";
	if($gHomeURL) {
		print "<font style=\"font-size:8pt;font-family:Tahoma\"><a href=$gHomeURL target=$gHomeURLTarget>go-home</a></font>&nbsp;&nbsp;"; 
	}
	print "</table>\n";
}

sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "<!-------------------------------------------------------->\n";
    print "<!--                                                    -->\n";
    print "<!--    ƾ: ̼                                -->\n";
    print "<!--    ڿ: zeusso\@nownuri.net                    -->\n";
    print "<!--    Ȩ: http://soback.kornet21.net/~zeusso    -->\n";
    print "<!--                                                    -->\n";
    print "<!--    ƾ:                                 -->\n";
    print "<!--    ڿ: thief\@khim.pe.kr                      -->\n";
    print "<!--    Ȩ: http://www.khim.pe.kr/                -->\n";
    print "<!--                                                    -->\n";
    print "<!--    Ų: â                                -->\n";
    print "<!--    ڿ: cchange\@hanmail.net                   -->\n";
    print "<!--    Ȩ: http://ww5.introcom.net/~cchange/     -->\n";
    print "<!--                                                    -->\n";
    print "<!-------------------------------------------------------->\n";
    print "<html>\n";
    print "<head>\n";
    print "    <title>cchange</title>\n";
    print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
    print "<style type='text/css'>\n";
    print "<!--\n";
    print " A:link    {color:#84ceff;text-decoration:none;}\n";
    print " A:visited {color:#84ceff;text-decoration:none;}\n";
    print " A:active  {color:#ff4040;text-decoration:none;}\n";
    print " A:hover  {color:#94b6ff;text-decoration:underline}\n";
    print "    body,td   { color:$gBaseText;font-size:9pt;font-family:verdana,Tahoma,}\n";
    print "    select,option,textarea,input {background-color:ffffff;font-size:9pt;font-size:9pt }\n";
    print "    form {font-size:8pt }\n";
    print "    .ver8 {font-family:tahoma,;font-size:7pt}\n";
    print "    .ver9 {font-family:tahoma;font-size:8pt}\n";
    print "body{background:url(images/bg.jpg)  no-repeat fixed right bottom;scrollbar-face-color: #FFFFFF; scrollbar-shadow-color:#84ceff;scrollbar-highlight-color: #ffffff; scrollbar-3dlight-color: #FFFFFF; scrollbar-darkshadow-color: #FFFFFF; scrollbar-track-color: #FFFFFF;scrollbar-arrow-color: #ffffff}\n";	
    print "-->\n";
    print "</style>\n";
    print "</head>\n";

    if($gDelayTime == 0) {
	    print "<body topmargin=15>\n";
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>\n";
        print "<body topmargin=15>\n";
    }
    print "<center>\n";    
    if($gBoardImage) {
        print "<img src=$gBoardImage>\n";
    }
    else {
        print "<table border=0 cellspacing=0 cellpadding=0><tr align=center><td>$gBoardTitle</td></tr></table>\n";
    }
    print "<br>\n";
}

sub HTMLFooter {
    print "</center>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

sub PageHeader {
    print "<table width=$gTableWidth border=0 cellspacing=1 cellpadding=3>\n";
    print "&nbsp;<td><font size=1 face=Tahoma>Total : $gNoOfData Articles : $gCurPage/$gTotPage</font></td><td><div align=right><a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=config_form><font size=1t>admin</font></a></td>\n";
    print "</table>\n";

}

sub PageFooter {
    &showSearchForm;
}
sub showInputForm {
    local($data,$subject,$content,$name,$myhome,$value);
    local(@value,@cookies);
    
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }

    &HTMLHeader;
       if($FORM{'l'}) {
        open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
            $data = <HANDLE>;
        close(HANDLE);
    @value = split(/\|/,$data);
        $subject = "Re: $value[5]";
        $content = "$value[6]<br>\n=+= $value[2] ۿ 亯 ϱ =+=\n";
        $content =~ s/<br>/\n/g;
        $content =~ s/<p>/\n\n/g;


        print "<form method=post action=$gCGI_URL>\n";    
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td height=22>&nbsp;&nbsp;&nbsp;&nbsp;亯 ϱ\n";
        print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
        print "</table><br>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n";
        print "<input type=hidden name=action value=write>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n"; 
        print "<input type=hidden name=n value=$FORM{'n'}>\n";
        print "<input type=hidden name=l value=$FORM{'l'}>\n"; 
        print "<table width=500 border=0 cellspacing=0 cellpadding=2>\n";
        print "<tr>\n";
        print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\"≯</font><td><input name=name value=\"$COOKIE{'UN'}\" type=text size=15 style=\"border:1 solid $gBaseText; background:;\">\n";
        if($COOKIE{'UE'} eq "<br>") {
            $COOKIE{'UE'} = "";
        }
        print "<font style=\"font-size:8pt;font-family:Tahoma\"≯</font> <input name=email value=\"$COOKIE{'UE'}\" type=text size=15  style=\"border:1 solid $gBaseText\">\n";
        print "<tr>\n";    
        print "<td align=center width=120><font style=\"font-size:8pt;font-family:Tahoma\">Ȩ</font>\n";
        print "<td><input name=myhome value=\"$COOKIE{'UH'}\" type=text size=40 maxlength=50 style=\"border:1 solid $gBaseText\">\n";
		print "<tr>\n";    
        print "<td align=center width=120><font style=\"font-size:8pt;font-family:Tahoma\"></font>\n";
        print "<td><input name=subject value=\"$subject\" type=text size=40 maxlength=30 style=\"border:1 solid $gBaseText;\">\n";    
        print "<tr>\n";
        print "<td align=center><font style=\"font-size:8pt;font-family:Tahoma\"></font>\n";
        print "<td><font style=\"font-size:8pt;font-family:Tahoma\"><input type=checkbox name=autolink value=enable checked>Auto link enable <input type=checkbox name=html value=enable>Html enable</font><br><textarea name=content rows=10 cols=46 style=\"border:1 solid $gBaseText\">$content</textarea>\n";
		if ($gAdminist eq "Y"){
			print "<input type=hidden name=action value=write2>\n";
			print "<tr>\n";
			print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\">йȣ</font></td>\n";
			print "<td><input type=password name=oldpasswd size=15 maxlength=8 style=\"border:1 solid $gBaseText\"> ڸ   ϴ\n";
		}
		else {
			print "<input type=hidden name=action value=write>\n";
			print "<tr>\n";
			print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\">йȣ</font></td>\n";
			print "<td><input type=password name=passwd size=15 maxlength=8 style=\"border:1 solid $gBaseText\">   ÿ ʿմϴ\n";
		}
        print "</table><br>\n";
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
        print "</table>\n";
        print "<p align=center>\n";
        print "<input type=submit value=write style=\"height:18px; background:; border:1 solid $gBaseText; cursor:hand\"> <input type=reset value=reset style=\"height:18px; background:; border:1 solid $gBaseText; cursor:hand\">\n";
        print "</form>\n";
    } 
    else {
        print "<form method=post action=$gCGI_URL>\n";    
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td height=22>&nbsp;&nbsp;&nbsp;&nbsp;۾\n";
        print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
        print "</table><br>\n"; 
        print "<input type=hidden name=id value=$FORM{'id'}>\n";
        print "<input type=hidden name=action value=write>\n";
        print "<input type=hidden name=n value=$FORM{'n'}>\n";
        print "<input type=hidden name=p value=1>\n";
        print "<table width=500 border=0 cellspacing=0 cellpadding=2>\n";
        print "<tr>\n";
        print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\"≯</font><td><input name=name value=\"$COOKIE{'UN'}\" type=text size=15 style=\"border:1 solid $gBaseText; background:;\">\n";
        print "<font style=\"font-size:8pt;font-family:Tahoma\"≯</font> <input name=email value=\"$COOKIE{'UE'}\" type=text size=15 style=\"border:1 solid $gBaseText; background:;\">\n";
        print "<tr>\n";    
        print "<td align=center width=120><font style=\"font-size:8pt;font-family:Tahoma\">Ȩ</font>\n";
        print "<td><input name=myhome value=\"$COOKIE{'UH'}\" type=text size=40 maxlength=50 style=\"border:1 solid $gBaseText; background:;\">\n";
        print "<tr>\n";    
        print "<td align=center width=120><font style=\"font-size:8pt;font-family:Tahoma\"></font>\n";
        print "<td><input name=subject type=text size=40 maxlength=30 style=\"border:1 solid $gBaseText; background:;\">\n";
        print "<tr>\n";
        print "<td align=center><font style=\"font-size:8pt;font-family:Tahoma\"></font>\n";
        print "<td><font style=\"font-size:8pt;font-family:Tahoma\"><input type=checkbox name=autolink value=enable checked>Auto link enable <input type=checkbox name=html value=enable>Html enable</font><br><textarea name=content rows=10 cols=46 style=\"border:1 solid $gBaseText; background:;\"></textarea>\n";
        if ($gAdminist eq "Y"){
            print "<input type=hidden name=action value=write2>\n";
            print "<tr>\n";
            print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\">йȣ</font></td>\n";
            print "<td><input type=password name=oldpasswd size=15 maxlength=8 style=\"border:1 solid $gBaseText; background:;\"> ڸ   ϴ\n";
        }
        else {
            print "<input type=hidden name=action value=write>\n";
		    print "<tr>\n";
            print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\">йȣ</font></td>\n";
            print "<td><input type=password name=passwd size=15 maxlength=8 style=\"border:1 solid $gBaseText; background:;\">   ÿ ʿմϴ\n";
        }
        print "</table><br>\n";
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
        print "</table>\n";
        print "<p align=center>\n";
        print "<input type=submit value=write style=\"height:18px; background:; border:1 solid $gBaseText; cursor:hand\"> <input type=reset value=reset style=\"height:18px; background:; border:1 solid $gBaseText; cursor:hand\">\n";
        print "</form>\n";
    } 
    &HTMLFooter;
}

sub writeData {
    &getNumber;
    &getVariable;

    print "Set-Cookie: UN=$name; expires=Sunday, 12-Dec-9999 12:12:12 GMT;\r\n";
    print "Set-Cookie: UE=$email; expires=Sunday, 12-Dec-9999 12:12:12 GMT;\r\n" unless($email eq "<br>");
    print "Set-Cookie: UH=$myhome; expires=Sunday, 12-Dec-9999 12:12:12 GMT;\r\n" unless($myhome eq "");

	&makeCryptPassword if($passwd);
    &appendIndexFile;
    &makeNewFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
        print "<p><b>$name</b>  Խǿ ߰Ͽϴ\n";
        print "<p> :: <a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>Խ</a> :: \n";
    &HTMLFooter;
}

sub getVariable {
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }
    unless($FORM{'name'} =~ /^\s*$/) {
        $name = "$FORM{'name'}";
        $name =~ s/\|/&#124;/g;
    }
    else {
        &error(no_name);
    }
    if($FORM{'email'} =~ /^.+\@.+(\..+)+/) {
        $email = "$FORM{'email'}";
        $email =~ s/</&lt;/g;
        $email =~ s/>/&gt;/g;
        $email =~ s/"/&quot;/g;
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "<br>";
    }
    unless($FORM{'subject'} =~ /^\s*$/) {
        $subject = "$FORM{'subject'}";
        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/"/&quot;/g;
        $subject =~ s/\|/&#124;/g;
    }
    else {
        &error(no_subject);
    }
    if($FORM{'content'}) {
        $content = "$FORM{'content'}";
        if($FORM{'html'} ne "enable") { 
            $content =~ s/</&lt;/g;
            $content =~ s/>/&gt;/g;
            $content =~ s/"/&quot;/g;
            $content =~ s/\|/&#124;/g;
        }
        if ($FORM{'autolink'} eq "enable"){
            $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.gif)/<img src=\"\/\/$2\">/gi;
            $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.jpg)/<img src=\"\/\/$2\">/gi;
            $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.bmp)/<img src=\"\/\/$2\">/gi;
            $content =~ s/(http:\/\/)([\w\~+\-\/\=\?\.\~\:]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
            $content =~ s/(ftp:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
            $content =~ s/(telnet:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
            $content =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<a href=\"mailto:$1\">$1<\/a>/gi;
		}
        $content =~ s/\r\n\r\n/<p>/g;
        $content =~ s/\r\n/<br>/g;
        $content =~ s/\|/&#124;/g;
    }
    else {
        &error(no_content);
    }
    if($FORM{'myhome'}) {
        $myhome = "$FORM{'myhome'}";
        $myhome =~ s/</&lt;/g;
        $myhome =~ s/>/&gt;/g;
        $myhome =~ s/"/&quot;/g;
        $myhome =~ s/\|/&#124;/g;
    }
    &getDate;
}

sub getDate {     
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    if($sec < 10) {
        $sec = "0$sec";
    }
    if($min < 10) {
        $min = "0$min";
    }
    if($hour < 10) {
        $hour = "0$hour";
    }
    $mon++;
    if($mon < 10) {
        $mon = "0$mon";
    }
    if($mday < 10) {
        $mday = "0$mday";
    }

    $year = $year + 1900;
    $date = "$year-$mon-$mday $hour:$min:$sec";
    $d = "$mon$mday";
}      

sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

sub makeNewFile { 
    open(HANDLE,">$gBaseDIR/messages/$filename.txt");
        print HANDLE "$gCryptPassword|$filename|$name|$email|$date|$subject|$content|$myhome\n";
    close(HANDLE);
}

sub appendIndexFile {
    local($data);
    local(@set,@datum,@value);
    
    @set = ('0'..'9');
    srand(time);
    $filename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";

    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    &lock;
    if($FORM{'l'}) {    
        open(HANDLE,">$gBaseDIR/$gIdxFile");
        foreach $data (@datum) {
            @value = split(/\|/,$data);
            if($value[1] eq $FORM{'l'}) {
                $thread = $value[0] + 1;
                print HANDLE "$data";
                print HANDLE "$thread|$filename|$subject|$name|$email|$date|0\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    else {
        $thread = 0;
        open(HANDLE,">$gBaseDIR/$gIdxFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "$thread|$filename|$subject|$name|$email|$date|0\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}

sub sendMail {
    open(MAIL,"|$gEmailPgm -t $gAdminEmail");
    print MAIL "To: $gAdminEmail\n";
    print MAIL "From: $name<$email>\n";
    print MAIL "Subject: $subject\n";
    $content =~ s/<p>/\n\n/g;
    $content =~ s/<br>/\n/g;
    print MAIL "$name wrote on $date";
    print MAIL "\n--------------------------------------------------\n";
    print MAIL "$content"; 
    print MAIL "\n--------------------------------------------------\n";
    close(MAIL);
}

sub error {
    local($error) = $_[0];

    &HTMLHeader;
    if($error eq "no_name") {
        print "<p≯ ݵ ؾ մϴ\n";
        print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
    }
    elsif ($error eq "no_subject") {
        print "<p> ݵ ؾ մϴ\n";
        print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
    }
    else {
        print "<p> ݵ ؾ մϴ\n";
        print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
    }
    &HTMLFooter;
}

sub followData {
    local($PrevNum,$PrevPage,$CurrNum,$NextNum,$NextPage,$data);
    local(@datum,@value,@PrevLine,@CurrLine,@NextLine);

    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);
    $PrevNum = $FORM{'n'}-1;
    $PrevPage = int(($PrevNum-1)/$gRecPerPage)+1;
    @PrevLine = split(/\|/,$datum[$PrevNum]);
   
    $CurrNum = $FORM{'n'};
    @CurrLine = split(/\|/,$datum[$CurrNum]); 

    $NextNum = $FORM{'n'}+1;
    $NextPage = int(($NextNum-1)/$gRecPerPage)+1;
    @NextLine = split(/\|/,$datum[$NextNum]);

    $gDataNumber = $FORM{'l'};
    &addHitCounter;

    open(HANDLE,"$gBaseDIR/messages/$gDataNumber.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    $actual_number = ($gNoOfData+1)-$FORM{'n'};
      print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
     print "<tr valign=middle  align=center bgcolor=#87DCFF>\n";
   print "<td><table width=100% height=10 border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7' cellpadding='1' cellspacing='0'><tr><td align=right><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&c=update_form&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber><font color='#fffff'>+</font></a><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&c=delete&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber><font color='#fffff'></font></a></td></tr></table></td></tr>\n";
    print "<tr align=left height=20><td bgcolor=#e7f7ff><font style=\"font-size:9pt;font-family:Tahoma;color:84ceff\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp<font color='#84ceff'><b>Name</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp$value[2]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</font></td></tr>\n";
    print "<tr><td colspan=99 background=$gIconURL/t_cl.gif width=$gTableWidth></td></tr>\n";
    print "<tr align=left height=22><td bgcolor=#e7f7ff><font style=\"font-size:8pt;font-family:Tahoma;color:84ceff\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font color='#84ceff'><b>Homepage</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$value[7]\" target=\"_blank\">$value[7]</a></font></td></tr>\n";
    print "<tr><td colspan=99 background=$gIconURL/_cl.gif width=$gTableWidth></td></tr>\n";    
    print "<tr align=left height=22><td bgcolor=#e7f7ff><font style=\"font-size:9pt;font-family:Tahoma;color:84ceff\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font color='#84ceff'><b>Title</b>&nbsp;<b>&nbsp;&nbsp;&nbsp$value[5]</b></font></td></tr>\n";
    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
    print "<br></br><ul><p>$value[6]</p></ul><br></br>\n";
    print "<tr><td colspan=99 background=$gIconURL/dot.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr></table>\n";

  
    
    
	
    print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td align=left>\n";
    print "<font style=\"font-size:8pt;font-family:Tahoma\"><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><img src=$gIconURL/index.gif border=0 align=absmiddle></a></font>\n";
    print "<td align=right>\n";
    if($FORM{'f'} < $gThreadNumber-1) {
        print "<font style=\"font-size:8pt;font-family:Tahoma\"><a href=$gCGI_URL?id=$FORM{'id'}&action=input_form&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber><img src=$gIconURL/reply.gif border=0 align=absmiddle></a>\n";
    }
    else {
        print "<font style=\"font-size:8pt;font-family:Tahoma\">reply</font>&nbsp;\n";
    }
    print "</table><br><br>\n";
}


sub addHitCounter {
    local($data,$temp);
    local(@datum,@value,@t);

    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");   
    foreach $data (@datum) {
        @value = split(/\|/,$data);             
        if ($value[1] eq $gDataNumber) {
            $value[6]++;
	    print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]\n";
        }
        else {
             print HANDLE $data;
        }
    }
    close(HANDLE);
    &unlock;

    open(HANDLE,"<$gBaseDIR/messages/$gDataNumber.txt");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);

    $t[8] = $t[8] + 1;
    open(HANDLE,">$gBaseDIR/messages/$gDataNumber.txt");
        print HANDLE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]|$t[7]|$t[8]|$t[9]";
    close(HANDLE);
}

sub searchData {
    local($data,$counter);
    local(@datum,@value);    

    &getNumber;
    &HTMLHeader;
    unless($FORM{'word'}) {
        print "<p>˻ Է ʾҽϴ\n";
        print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
    }
    else {
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr valign=middle align=center bgcolor=#87DCFF>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7' cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>No</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Subject</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Name</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Date</b></font></td></tr></table></td>\n";
    print "<td><table width=100% height=100% border='1' bordercolordark='#ffffff' bordercolorlight='#7bcef7'  cellpadding='1' cellspacing='0'><tr><td align=center><font color='#ffffff'><b>Read</b></font></td></tr></table></td>\n";
   


        open(HANDLE,"$gBaseDIR/$gIdxFile");
            @datum = <HANDLE>;
        close(HANDLE);

        $counter = 0 ;
        for($i=1;$i<=$gNoOfData;$i++ ) {
            @v = split(/\|/,$datum[$i]);            
            open(HANDLE,"$gBaseDIR/messages/$v[1].txt");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/,$data);
            if($FORM{'cp'} eq 'subject') {  
                if($value[5] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
                }
            }
	        elsif($FORM{'cp'} eq "name") { 
	            if($value[2] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
		        }
            } 
	        else { 
	            if($value[6] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
                }
            }
		}
        print "<tr><td colspan=5 align=center  height=22>\n";
        print "˻ <b>$FORM{'word'}</b>()  $counter Խù ˻Ǿϴ\n";
        print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
        print "</table>\n";
        print "<br> - <a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><img src=$gIconURL/index.gif border=0 align=absmiddle></a> - \n";
    } 
    &HTMLFooter;  
}

sub printRecord {
    local($short_subject,$short_date,$actual_number);

    $actual_number = ($gNoOfData+1)-$i;
        print "<tr align=center onMouseOver=this.style.backgroundColor='$gListHover' onMouseOut=this.style.backgroundColor=''><td>$actual_number</font>\n";
    $short_subject = substr($v[2],0,50);
    if ($v[0] == 0) {
        print "<td height=22 align=left>&nbsp;&nbsp;<img src=$gIconURL/item.gif border=0 align=absmiddle> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=0&p=$FORM{'p'}&n=$i&l=$v[1]>&nbsp;&nbsp;$short_subject</a>";
    }
    else {
        print "<td height=22 align=left>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/item_reply.gif border=0 align=absmiddle> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=1&p=$FORM{'p'}&n=$i&l=$v[1]>&nbsp;&nbsp;$short_subject</a>";
    } 
    if ($v[4] eq "<br>") {
        print "<td align=center>$v[3]\n";
    }
    else {
        print "<td align=center><a href=mailto:$v[4] title=\"$v[4]\">$v[3]</a>\n";
    }
    $short_date = substr($v[5],0,10);
        print "<td align=center>$short_date";
        print "<td align=center>$v[6]";
        print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
}

sub showSearchForm {
    print "<form method=post action=$gCGI_URL>\n";
    print "<table border=0 width=100% cellspacing=0 cellpadding=0>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=search>\n";
    print "<input type=hidden name=p value=$gCurPage>\n";
    print "<tr align=center valign=middle><td>\n";
    print "<input type=checkbox name=cp  value=subject>\n";
    print "<input type=checkbox name=cp  value=name≯\n";
    print "<input type=checkbox name=cp  value=content>\n";
    print "</td></tr>\n";
    print "<tr> <td align=center><input type=text size=15 name=word style=\"height:20px;background:;border:1 $gBaseText solid\">&nbsp;<font color='#158BA9'><input type=submit value=\"˻\" style=\"height:20px;background:;border:1 solid $gBaseText;cursor: hand\"</font></td></tr>\n";
    print "</table>\n";
    print "<table border=0 cellpadding=0 cellspacing=2><tr><td align=center><a href=http://soback.kornet21.net/~zeusso target=_blank title=\" ϴ Ȩ \"><font style=\"font-size:8pt\">wonie</a> <font color=#000000>::: <a href=http://www.khim.pe.kr/ target=_blank title=\"  Ȩ \">Khim</font></a> <font color=#000000>::: <a href=http://ww5.introcom.net/~cchange/ target=_blank title=\" ¯ Ȩ \">cchange</font></a></td></tr></table>\n";
    print "</form>\n";
}

sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "update_form";
    }
 
    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=n value=$FORM{'n'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print " йȣ Էϼ<br>\n";
    print "<input type=password name=passwd size=25 maxlength=8 style=\"background:;border:1 $gBaseText solid\"><br>\n";
    print "<input type=submit value=ϱ style=\"height:20px;background:;border:1 solid $gBaseText;cursor: hand\">\n" if($command eq "delete");
    print "<input type=submit value=ϱ style=\"height:20px;background:;border:1 solid $gBaseText;cursor: hand\">\n" if($command eq "update_form");
    print "</form>\n";
    &HTMLFooter;       
}

sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
            print "<p> йȣ ġ ʽϴ\n";        
            print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
        &HTMLFooter;
    } 
    
}

sub deleteData {
    local(@datum,@value);
    unless(-e "$gBaseDIR/messages/$FORM{'l'}.txt") {
	    $gDelayTime = 500;
        &HTMLHeader;
            print "<p> Խù ̹ Ǿϴ\n";
            print "<p> :: <a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>Խ</a> :: \n";
        &HTMLFooter;
    }

    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    if($#datum <= 1) {
        open(HANDLE,">$gBaseDIR/messages/00000000");
            print HANDLE "99999999\n";
        close(HANDLE);
    }

    else {
        if($FORM{'n'} == 1) {
            @value = split(/\|/, $datum[2]);
            open(HANDLE,">$gBaseDIR/messages/00000000");
               print HANDLE "$value[1]\n";
            close(HANDLE);
        }
        else {
            if($FORM{'n'} == $#datum) {
                $link = "99999999";
            }
            else {
                @value = split(/\|/, $datum[$FORM{'n'}+1]);
                $link = $value[1];
            }

            @value = split(/\|/, $datum[$FORM{'n'}-1]);
            open(HANDLE,"<$gBaseDIR/messages/$value[1].txt");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/, $data);
            open(HANDLE,">$gBaseDIR/messages/$value[1].txt");
            print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]|$value[7]|$link\n";
            close(HANDLE);
        }
    }

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} ne $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);
    &unlock;

    unlink("$gBaseDIR/messages/$FORM{'l'}.txt");
    $gNoOfData--;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
        print "<p>Խù  Ǿϴ\n";
        print "<p> :: <a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>Խ</a> :: \n";
    &HTMLFooter;
}

sub showUpdateForm {
    local($data);
    local(@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td height=22>&nbsp;&nbsp;&nbsp;&nbsp;---\n";
    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "</table><br>\n";
    print "<table width=500 border=0 cellspacing=0 cellpadding=2>\n";
    print "<tr>\n";
    print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\">name</font>\n";
    print "<td><input name=name type=text size=15 value=\"$value[2]\" style=\"border:1 solid $gBaseText; background:;\">\n";
    $value[3] =~ s/<br>//g;
    print "<font style=\"font-size:8pt;font-family:Tahoma\">e-mail</font> <input name=email type=text size=15 value=\"$value[3]\" style=\"border:1 solid $gBaseText; background:;\">\n";
    print "<tr>\n";    
    print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\">homepage</font>\n";
    print "<td><input name=myhome value=\"$value[7]\" type=text size=40 maxlength=50 style=\"border:1 solid $gBaseText; background:;\">\n";
    print "<tr>\n";    
    print "<td align=center width=100><font style=\"font-size:8pt;font-family:Tahoma\">subject</font>\n";
    print "<td><input name=subject type=text size=40 value=\"$value[5]\" style=\"border:1 solid $gBaseText; background:;\">\n";    
    print "<tr>\n";
    print "<td align=center><font style=\"font-size:8pt;font-family:Tahoma\">comment</font>\n";
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;
    print "<td><font style=\"font-size:8pt;font-family:Tahoma\"><input type=checkbox name=autolink value=enable checked>auto link enable <input type=checkbox name=html value=enable>html enable</font><br><textarea name=content rows=10 cols=46 style=\"border:1 solid $gBaseText; background:;\">$value[6]</textarea>\n";
    print "</table><br>\n";
    print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "</table>\n";
    print "<p align=center>\n";
    print "<input type=submit value=write style=\"height:18px; background:; border:1 solid $gBaseText; cursor:hand\"> <input type=reset value=reset style=\"height:18px; background:; border:1 solid $gBaseText; cursor:hand\">\n";
    print "</form>\n";
    &HTMLFooter;       
}

sub updateData {
    local($temp);
    local(@datum,@value,@t);
  
    &getVariable;
    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
            print HANDLE "$value[0]|$FORM{'l'}|$subject|$name|$email|$date|$value[6]";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    &unlock;

    open(HANDLE,"<$gBaseDIR/messages/$FORM{'l'}.txt");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);

    open(HANDLE,">$gBaseDIR/messages/$FORM{'l'}.txt");
        print HANDLE "$t[0]|$FORM{'l'}|$name|$email|$date|$subject|$content|$myhome|$t[8]|$t[9]";
    close(HANDLE);

    $gDelayTime = 500;
    &HTMLHeader;
        print "<p>Խù  Ǿϴ\n";
        print "<p> :: <a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>Խ</a> :: \n";
    &HTMLFooter;
}

sub showAdminLogin {
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<form action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print " йȣ ϼ\n";
        print "<table>\n";
        print "<tr align=center><td height=60 width=400>\n";
        print " йȣ <input type=password name=newpasswd size=20 maxlength=8 style=\"background:;border:1 $gBaseText solid\"><br>\n";
        print "йȣ Է <input type=password name=repasswd size=20 maxlength=8 style=\"background:;border:1 $gBaseText solid\"><br>\n";
        print "</table>\n";
        print "<input type=submit value=ϱ style=\"height:20px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
        print "</form>\n";
    }
    else {
        print "<form method=post action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print " йȣ Էϼ<br>\n";
        print "<input type=password name=oldpasswd size=25 maxlength=8 style=\"background:;border:1 $gBaseText solid\"><br>\n";
        print "<input type=submit value=ϱ style=\"height:20px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
        print "</form>\n";
    }
    close(HANDLE);
    &HTMLFooter;
}
 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);
    
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	                close(HANDLE);
            }
            else {
                &HTMLHeader;
                    print "<p> йȣ Է ʾҽϴ\n";
                    print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
                print "<p> йȣ ġ ʽϴ\n";
                print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
            &HTMLFooter;
        } 
    } 

    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
                print "<p> йȣ ġ ʽϴ\n";
                print "<p> :: <a href=\"javascript:history.back()\">ڷ</a> :: \n";
            &HTMLFooter;
        }
    }
}

sub showConfigForm {
    &HTMLHeader;
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::  ȣ  ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<form action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";
    print "<tr><td>ο йȣ</td><td align=right> <input type=password name=newpasswd size=10 maxlength=8></td></tr>\n";
    print "<tr><td>йȣ Է</td><td align=right> <input type=password name=repasswd size=10 maxlength=8></td></tr>\n";
    if($gMakeBoard eq "Y") {
        $gMakeBoard = "";
    } 
    else {
        $gMakeBoard = "";
    }
	print "<tr><td align=right>Խ ߰:</td><td><font color=#ff0000 size=-1><b>$gMakeBoard</b></font></td></tr>\n";
	print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td></td><td align=right><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td> ׸</td><td align=right><input type=text name=BackImage value=\"$gBackImage\" size=30></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td> </td><td align=right><input type=text name=BoardTitle value=\"$gBoardTitle\" size=30></td></tr>\n";
    print "<tr><td> ׸</td><td align=right><input type=text name=BoardImage value=\"$gBoardImage\" size=30></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ⺻ ȯ  ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td>⺻ ڻ</td><td align=right><input type=text name=BaseText value=\"$gBaseText\" size=10></td></tr>\n";
	print "<tr><td>⺻ ũ</td><td align=right><input type=text name=TextSize value=\"$gTextSize\" size=10></td></tr>\n";
	print "<tr><td>⺻ ۲</td><td align=right><input type=text name=TextFamily value=\"$gTextFamily\" size=10></td></tr>\n";
	print "<tr><td>ũ </td><td align=right><input type=text name=Link value=\"$gLink\" size=10></td></tr>\n";
    print "<tr><td>湮 ũ</td><td align=right><input type=text name=LinkVisited value=\"$gLinkVisited\" size=10></td></tr>\n";
    print "<tr><td>Ȱȭ ũ</td><td align=right><input type=text name=LinkActive value=\"$gLinkActive\" size=10></td></tr>\n";
    print "<tr><td>ũ hover</td><td align=right><input type=text name=LinkHover value=\"$gLinkHover\" size=10></td></tr>\n";
    print "<tr><td>list hover</td><td align=right><input type=text name=ListHover value=\"$gListHover\" size=10></td></tr>\n";
	print "<tr><td>Խ </td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=10></td></tr>\n";
	print "<tr><td> </td><td align=right><input type=text name=TableCell value=\"$gTableCell\" size=10></td></tr>\n";
	print "<tr><td>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=10></td></tr>\n";
    print "<tr><td> </td><td align=right><input type=text name=ThreadNumber value=\"$gThreadNumber\" size=10></td></tr>\n";
    print "<tr><td> </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=10></td></tr>\n";
    print "<tr><td> 뺸</td><td align=right><select name=MailInform>";
    if($gMailInform eq "Y") {
        print "<option value=Y selected>Ѵ";
        print "<option value=N>";
    }
    else {
        print "<option value=Y>Ѵ";
        print "<option value=N selected>";
    }
    print "</select></td></tr>\n";
    print "<tr><td>ڸ ۾</td><td align=right><select name=Administ>";
    if($gAdminist eq "Y") {
        print "<option value=Y selected>Ѵ";
        print "<option value=N>";
    }
    else {
        print "<option value=Y>Ѵ";
        print "<option value=N selected>";
    }
    print "</select></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ΰ   ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td>Admin E-Mail</td><td align=right><input type=text name=AdminEmail value=\"$gAdminEmail\" size=30></td></tr>\n";
    print "<tr><td>Sendmail Path</td><td align=right><input type=text name=EmailPgm value=\"$gEmailPgm\" size=30></td></tr>\n";
    print "<tr><td>URL</td><td align=right><input type=text name=HomeURL value=\"$gHomeURL\" size=30></td></tr>\n";
    print "<tr><td>Target</td><td align=right><input type=text name=HomeURLTarget value=\"$gHomeURLTarget\" size=10></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p>\n";
    print "<input type=submit value=ϱ style=\"height:20px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
    print "</form>\n";
    &HTMLFooter;
}

sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gBackColor = $FORM{'BackColor'};
    $gBackImage = $FORM{'BackImage'} if($FORM{'BackImage'} =~ /^http:\/\// || $FORM{'BackImage'} eq "");
    $gBoardTitle = $FORM{'BoardTitle'};
    $gBoardImage = $FORM{'BoardImage'} if($FORM{'BoardImage'} =~ /^http:\/\// || $FORM{'BoardImage'} eq "");
    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
    $gThreadNumber = $FORM{'ThreadNumber'} if($FORM{'ThreadNumber'} >= 1);
    $gListNumber = $FORM{'ListNumber'};
    $gMailInform = $FORM{'MailInform'};
    $gAdminEmail = $FORM{'AdminEmail'} if($FORM{'AdminEmail'} =~ /.+\@.+(\..+)+/ || $FORM{'AdminEmail'} eq "");
    $gEmailPgm = $FORM{'EmailPgm'};
    $gHomeURL = $FORM{'HomeURL'};
    $gHomeURLTarget = $FORM{'HomeURLTarget'};
    $gBaseText = $FORM{'BaseText'};
    $gLink = $FORM{'Link'};
    $gLinkVisited = $FORM{'LinkVisited'};
    $gLinkActive = $FORM{'LinkActive'};
    $gLinkHover = $FORM{'LinkHover'};
    $gTableCell = $FORM{'TableCell'};
    $gListHover = $FORM{'ListHover'};
    $gAdminist = $FORM{'Administ'};
	$gTextSize = $FORM{'TextSize'};
	$gTextFamily = $FORM{'TextFamily'};
    &putEnvVar;
    $gCurPage = $FORM{'p'};
    &readData;
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;

    while(-e $LockFile && time < $EndTime) {}
    open(LOCK,">$LockFile");
    chmod 0666,$LockFile;

    if($gLockFlag eq 'Y') {
        flock(LOCK,2);
    }
    $gLockStat = 'Y';
}    

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";

    if($gLockStat eq 'Y') {
        if($gLockFlag eq 'Y') {
            flock(LOCK,8); 
        }
        close(LOCK);
        if(-e $LockFile) { 
            unlink($LockFile);
        }
        $gLockStat = 'N'; 
    }
}
